function OnScreenConsole() {
    this.logs = [];
    this.maxLogs = 400;
    this.autoscroll = true;
}

OnScreenConsole.prototype = {
    initialize: function(id) {
        this.container = document.getElementById(id);
        if (this.container) {
            this.container.classList.add("on-screen-console");

            var title = document.createElement("div");
            title.className = "console-title";

            var titleSpan = document.createElement("span");
            titleSpan.innerText = "Console";

            var checkboxContainer = document.createElement("div");
            var checkbox = document.createElement("input");
            checkbox.type = "checkbox";
            checkbox.checked = this.autoscroll;

            checkbox.addEventListener("change", function(e) {
                this.autoscroll = e.target.checked;
            }.bind(this));

            var checkboxLabel = document.createElement("label");
            checkboxLabel.innerText = "Autoscroll";

            var content = document.createElement("div");
            content.className = "console-content";

            this.console = document.createElement("pre");

            title.appendChild(titleSpan);
            title.appendChild(checkboxContainer);

            checkboxContainer.appendChild(checkbox);
            checkboxContainer.appendChild(checkboxLabel);

            this.container.appendChild(title);
            this.container.appendChild(content);
            content.appendChild(this.console);
        }
    },

    setMaxLogs: function(max) {
        this.maxLogs = max;
    },

    _log: function(message) {
        if (this.console) {
            this.logs.push(message);
            if (this.logs.length > this.maxLogs) {
                this.logs.shift();
            }

            this.console.innerText = this.logs.join("\n");

            if (this.autoscroll) {
                this.console.parentElement.scrollTop = 0xffffffff;
            }
        }
    },

    log: function(message) {
        this._log(message);
        console.log(message);
    },

    error: function(message) {
        this._log(message);
        console.error(message);
    },

    warn: function(message) {
        this._log(message);
        console.warn(message);
    }
};